/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITag;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumFilterbyAttributePresence;
import cdac.medinfo.sdk.dcm30_04.enums.EnumFilterbyOperator;
import cdac.medinfo.sdk.dcm30_04.enums.EnumImageSetSelectorUsageFlag;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;

/**
* This item class contains the methods to set, get and validate the attribute present in Filter Operations Sequence .
 */

public class FilterOperationsSequenceItem extends Item{


	

	HangingProtocolSelectorAttributeContextMacro objHangingProtocolSelectorAttributeContextMacro;
	HangingProtocolSelectorAttributeValueMacro objHangingProtocolSelectorAttributeValueMacro;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	FilterOperationsSequenceItem()
	{
		super();
	}


	/**
	 * This constructor creates the item and internal code sequence macro with specified TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	FilterOperationsSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates FilterOperationsSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	FilterOperationsSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}
	
	/**
	 * This method returns the Hanging Protocol Selector Attribute Context Macro
	 * @return - instance of {@link HangingProtocolSelectorAttributeContextMacro} 
	 */
	public HangingProtocolSelectorAttributeContextMacro getHangingProtocolSelectorAttributeContextMacro()
	{
		if(objHangingProtocolSelectorAttributeContextMacro == null)
		{
			objHangingProtocolSelectorAttributeContextMacro = new HangingProtocolSelectorAttributeContextMacro(this);
			return objHangingProtocolSelectorAttributeContextMacro;
		}
		return objHangingProtocolSelectorAttributeContextMacro;
	}
	/**
	 * This method returns the Hanging Protocol Selector Attribute Value Macro
	 * @return - instance of {@link HangingProtocolSelectorAttributeValueMacro} 
	 */
	public HangingProtocolSelectorAttributeValueMacro getHangingProtocolSelectorAttributeValueMacro()
	{
		if(objHangingProtocolSelectorAttributeValueMacro == null)
		{
			objHangingProtocolSelectorAttributeValueMacro = new HangingProtocolSelectorAttributeValueMacro(this);		
			return objHangingProtocolSelectorAttributeValueMacro;
		}
		return objHangingProtocolSelectorAttributeValueMacro;
	}
	
	/**
	 * Validates all the attributes in FilterOperationsSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{   
		try
		{
			if(contains(0x0072,0x0402) && contains(0072,0026))
					throw new ConditionFailedException("0x0072,0x0402") ;
			if(contains(0x0072,0x0404) && (!contains(0072,0026) && contains(0072,0406)))
				throw new ConditionFailedException("0x0072,0x0404") ;
			if(contains(0x0072,0x0026) && contains(0072,0402))
				throw new ConditionFailedException("0x0072,0x0026") ;
			if(contains(0x0072,0x0050) && (!contains(0072,0026) || (!contains(0072,0402))||(!contains(0072,0406))))
				throw new ConditionFailedException("0x0072,0x0050") ;
			if(contains(0x0072,0x0028) && (!contains(0072,0026) && (!contains(0072,0406))))
				throw new ConditionFailedException("0x0072,0x0028") ;
			if(contains(0x0072,0x0406) && (!contains(0072,0402) || (!contains(0072,0026)))||contains(0072,0404))
				throw new ConditionFailedException("0x0072,0x0406") ;
		}
		catch(ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),ce); 
		}
		return true;
	}
	
	/**
	 * Sets the category of the filter operation.
	 * @param strFilterbyCategory Specifies type of the value encoded in this Item
	 */
	public void setFilterbyCategory(String strFilterbyCategory)
	{
		/* Accept the Value Type in String format of type CS.
		 * Category of the filter operation
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0072, 0x0402, strFilterbyCategory,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072, 0x0402,DicomConstants.DCM_DT_CS, strFilterbyCategory);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves type of the value encoded in this Item
	 * @return String - Type of the value encoded in this Item
	 */
	public String getFilterbyCategory()
	{
		Object objValue = getValue(0x0072, 0x0402);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets the category of the filter operation.
	 * Required if Selector Attribute (0072,0026) is present and Filter-by Operator(0072,0406) is not present.
	 * @param enumFilterbyAttributePresence 
	 * Enumerated Values: PRESENT,NOT_PRESENT
	 */
	public void setFilterbyAttributePresence(EnumFilterbyAttributePresence enumFilterbyAttributePresence)
	{
		/* Accept the Value Type in String format of type CS.
		 * Operation to be applied based on the presence or absence of the attribute represented by Selector 
		 * Attribute (0072,0026) in each image of the Image Set.
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0072, 0x0404, enumFilterbyAttributePresence,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072, 0x0404,DicomConstants.DCM_DT_CS, enumFilterbyAttributePresence);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves type of the value encoded in this Item
	 * @return String - Type of the value encoded in this Item
	 */
	public String getFilterbyAttributePresence()
	{
		Object objValue = getValue(0x0072, 0x0404);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets the Selector Attribute Tag of the attribute which was overridden.
	 * @param objITag Tag object of Override Parameter Pointer.
	 */
	public void setSelectorAttribute(ITag objITag)
	{
		/* Accept the Value Type in String format of type AT.
		 * Data Element Tag of an Attribute from an Image IOD to use as a filter
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0072,0x0026, objITag,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072,0x0026,DicomConstants.DCM_DT_AT, objITag);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Selector Attribute Tag of the attribute which was overridden.
	 * @return String - Tag object of Override Parameter Pointer.
	 */
	public ITag getSelectorAttribute()
	{
		Object objValue = getValue(0x0072,0x0026);
		if(objValue != null)
			return (ITag)objValue;
		return null;
	}

	/**
	 * Sets the Selector AttributeVR Defined in Terms of TEXT
	 * @param strSelectorAttributeVR Specifies type of the value encoded in this Item
	 */
	public void setSelectorAttributeVR(String strSelectorAttributeVR)
	{
		/* Accept the Value Type in String format of type CS.
		 * The Value Representation of Selector Attribute (0072,0026).
		 * Required if Selector Attribute (0072,0026) or Filter-by Category (0072,0402),and 
		 * Filter-by Operator (0072,0406) are present.
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0072, 0x0050, strSelectorAttributeVR,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072, 0x0050,DicomConstants.DCM_DT_CS, strSelectorAttributeVR);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves type of the value encoded in this Item
	 * @return String - Type of the value encoded in this Item
	 */
	public String getSelectorAttributeVR()
	{
		Object objValue = getValue(0x0072, 0x0050);
		if(objValue != null)
			return objValue.toString();
		return null;
	}


	/**
	 * Sets Selector Value Number
	 * @param shSelectorValueNumber short value of Number of significant bits
	 */
	public void setSelectorValueNumber(short shSelectorValueNumber)
	{
		/* Accept the SelectorValueNumber of type US.
		 * Positive integer identifying which value of the attribute identified by SelectorAttribute (0072,0026) is to be used for filtering.
		 * The value 1 identifies the first value. The value zero identifies any value.
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)	
			objIDataElement = new ImplicitDE(0x0072,0x0028,shSelectorValueNumber,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072,0x0028,DicomConstants.DCM_DT_US, shSelectorValueNumber);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves Number of significant bits within the waveform samples
	 * @return short - short value of Number of significant bits
	 */
	public short getSelectorValueNumber()
	{
		Object objValue = getValue(0x0072,0x0028);
		if(objValue != null)
			return Short.parseShort(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}

	/**
	 * Sets the Filter by Operator in Terms of TEXT
	 * @param enumFilterbyOperator Specifies type of the value encoded in this Item
	 */
	public void setFilterbyOperator(EnumFilterbyOperator enumFilterbyOperator)
	{
		/*Accept the Value Type in String format of type CS.
		 * Operation to be applied between the value(s) in the Hanging Protocol SelectorAttribute Value Macro ("selector"), 
		 * and the value(s) of the attribute identified bySelector Attribute (0072,0026)
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0072, 0x0406, enumFilterbyOperator,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072, 0x0406,DicomConstants.DCM_DT_CS, enumFilterbyOperator);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves type of the value encoded in this Item
	 * @return String - Type of the value encoded in this Item
	 */
	public String getFilterbyOperator()
	{
		Object objValue = getValue(0x0072, 0x0406);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	
	/**
	 * Sets the Filter by Operator in Terms of TEXT
	 * @param enumFilterbyOperator Specifies type of the value encoded in this Item
	 */
	public void setImageSetSelectorUsageFlag(EnumImageSetSelectorUsageFlag enumImageSetSelectorUsageFlag)
	{
		/*Accept the Value Type in String format of type CS.
		 * Specifies the behavior of the Filter-by Operator (0072,0406) when SelectorAttribute (0072,0026) is not available in the image
		 * or does not contain a value specified by Selector Value Number (0072,0028)
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0072, 0x0024, enumImageSetSelectorUsageFlag,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072, 0x0024,DicomConstants.DCM_DT_CS, enumImageSetSelectorUsageFlag);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves type of the value encoded in this Item
	 * @return String - Type of the value encoded in this Item
	 */
	public String getenumImageSetSelectorUsageFlag()
	{
		Object objValue = getValue(0x0072, 0x0024);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	
}
